using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SHDocVw;

namespace SCC_File_Diff_Report_Utility
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }
        public long ttCookie;
        public string ttProject;
        public string ttUser;
        public string ttUserPassword;
        public string ttSOAPURL;
        public string ttFilter;
        public ttsoapcgi ttSOAP;

        public Boolean tryFailed;
        public string errMsg; 

        private void btnClose_Click(object sender, EventArgs e)
        {
            if (ttCookie > 0)
            {
                ttSOAP.DatabaseLogoff(ttCookie);
            }
            Application.Exit();
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            if (cmbTTProj.Text == "")
            {
                MessageBox.Show("You need to select a project to connect to", "SCC File Diff Report Utility");
            }
            else
            {
                tryFailed = false;
                ttUser = txtTTUserName.Text;
                ttUserPassword = txtTTUserPass.Text;
                ttProject = cmbTTProj.Text;
                try
                {
                    ttCookie = ttSOAP.DatabaseLogon(ttProject, ttUser, ttUserPassword);
                }
                catch (Exception fcc)
                {
                    tryFailed = true;
                    errMsg = fcc.Message;
                }
                if ((tryFailed == true) || (ttCookie == 0))
                {
                    MessageBox.Show("Unable to connect to Soap Server or Project.\n" + errMsg, "SCC File Diff Report Utility");

                }
                else
                {
                    MessageBox.Show("Logged in to " + ttProject + ".", "SCC File Diff Report Utility");
                    cmbTTFilter.Enabled = true;
                    CFilter[] ttFilterList = ttSOAP.getFilterList(ttCookie);
                    for (int i = 0; i < ttFilterList.Length; i++)
                    {
                        cmbTTFilter.Items.Add(ttFilterList[i].name);
                    }
                   
                }
            }
            

            

        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void cmbTTProj_DropDown(object sender, EventArgs e)
        {
            if (txtSOAPAdd.Text == "")
            {
                MessageBox.Show("You need to enter a SOAP server address","SCC File Diff Report Utility");
            }
            else
            {
                cmbTTProj.Items.Clear();
                ttSOAPURL = txtSOAPAdd.Text;
                ttSOAP = new ttsoapcgi();
                CDatabase[] dbList = ttSOAP.getDatabaseList();
                for (int i = 0; i < dbList.Length; i++)
                {
                    cmbTTProj.Items.Add(dbList[i].name);
                }
            }
        }

        private void btnRunReport_Click(object sender, EventArgs e)
        {
            CTableColumn[] ctc = new CTableColumn[] { };
            CDatabaseTable[] ctf = ttSOAP.getTableList(ttCookie);//Get defect table name
            CRecordListSoap crl = ttSOAP.getRecordListForTable(ttCookie, ctf[0].name, ttFilter, ctc);
            CDefect defToProc = null;
                htmlReporter.CreateReportFile(ttFilter,Application.StartupPath.ToString() + "\\SCCFileReport.html");
                for (int j = 0; j < crl.records.Length; j++)
                {
                    defToProc = ttSOAP.getDefect(ttCookie, Convert.ToInt64(crl.records[j].row[0].value), "", false);

                    Logger.WriteLine(defToProc.defectnumber.ToString() + "  " + defToProc.summary);
                    htmlReporter.WriteLine("</br></br>");
                    htmlReporter.WriteLine("<table border width='90%' align='center'>");
                    htmlReporter.WriteLine("<tr><td>No.</td><td>Summary</td></tr>");
                    htmlReporter.WriteLine("<tr>");

                    htmlReporter.WriteLine("<td>" + defToProc.defectnumber.ToString() + "</td>");
                    htmlReporter.WriteLine("<td>" + defToProc.summary + "</td>");
                    htmlReporter.WriteLine("</tr>");

                    if (!(defToProc.pSCCFileList == null))
                    {
                        CSCCFileRecord[] sccFiles = defToProc.pSCCFileList;
                        //Logger.WriteLine("Defect " + defToProc.defectnumber + " has "this many SCC Files: " + sccFiles.Length.ToString());

                        for (int h = 0; h < sccFiles.Length; h++)
                        {
                            Logger.WriteLine(sccFiles[h].mstrFileName + "  " + sccFiles[h].mstrFixedRevision);
                            htmlReporter.WriteLine("<tr>");

                            htmlReporter.WriteLine("<td COLSPAN = '2'><PRE><b>File :</b>" + sccFiles[h].mstrFileName);
                            htmlReporter.WriteLine("<b>Version :</b> " + sccFiles[h].mstrFixedRevision + "</PRE></td>");


                            string sccFile = sccFiles[h].mstrFileName;
                            string fixRev = sccFiles[h].mstrFixedRevision;


                            string scmServer = "127.0.0.1:4900";
                            string scmUser = "Administrator";
                            string scmPassword = "password";
                            string commandParams = "";
                            /* now let's parse the results
                            we know that the result will be in the format:
                            <branch name>::<repo path/filename>
                                                                 */

                            //first, we find the position of the first colon to get the branch name
                            int pos = sccFile.IndexOf(":");
                            string branchName = sccFile.Substring(0, pos);
                            //we will remove the branch name and colons from the rest of the string we have to parse
                            sccFile = sccFile.Substring(pos + 2);
                            //let's reset the pos variable so we can use it again
                            pos = 0;
                            //next, we find the last "/".  Anything before this will the repo and anything after will be the file name
                            pos = sccFile.LastIndexOf("/");
                            string repoName = sccFile.Substring(0, pos);
                            string fileName = sccFile.Substring(pos + 1);

                            /*
                            Now let's run the command to get the file from Surround SCM-
                               * Here is the syntax of the command:
                               * 
                               * sscm diff File [-bBranch1[:Branch2]] [-h] [-pRepository] [-i|-i-]
                                       [-uDiffUtility] [-c] [-vVersion1[:Version2]] [-y[Username:Password|+]]
                                         [-zSCMServerAddr:PortNum] [+u]
                               * 
                               */
                            if ((fixRev != null) && (fixRev != "1"))
                            {
                                if (fixRev.Contains(","))
                                {
                                    fixRev = fixRev.Substring(fixRev.LastIndexOf(",") + 2);

                                }
                                int fixRevint = Convert.ToInt32(fixRev);
                                int prevRevint = fixRevint - 1;
                                string prevRev = prevRevint.ToString();
                                commandParams = "diff " + "\"" + fileName + "\"" + " -b" + "\"" + branchName + "\"" + " -p" + "\"" + repoName + "\"" + " -v" + fixRev + ":" + prevRev + " -i" + " -y" + "\"" + scmUser + ":" + scmPassword + "\"" + " -z" + scmServer;

                                string sscmresult = sscmexe.sscmCMD(commandParams);

                                Logger.WriteLine(sscmresult);

                                htmlReporter.WriteLine("<tr>");
                                htmlReporter.WriteLine("<td  COLSPAN = '2'><PRE>" + sscmresult + "</PRE></td></tr>");
                            }
                            Logger.WriteLine(" ");
                            Logger.WriteLine("--------------------------------");
                            Logger.WriteLine(" ");


                        }
                        Logger.WriteLine(" ");
                        Logger.WriteLine("================================================================");
                        Logger.WriteLine(" ");
                        htmlReporter.WriteLine("</TABLE>");
                    }
                    else
                    {
                        htmlReporter.WriteLine("<tr>");
                        htmlReporter.WriteLine("<td COLSPAN = '2'>Defect does not have any SCC files</td>");
                    }
                }
                htmlReporter.FinishFile();
        }

        private void cmbTTFilter_DropDownClosed(object sender, EventArgs e)
        {
            if (!(cmbTTFilter.SelectedItem.ToString() == ""))
            {
                btnRunReport.Enabled = true;
                ttFilter = cmbTTFilter.SelectedItem.ToString();
            }
        }


    }
}