/*******************************************************************************
 * Copyright 2008 Seapine Software, Inc. All rights reserved.
 * 
 * IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
 * in consideration of your agreement to the following terms, and your use, installation,
 * modification or redistribution of this Software constitutes acceptance of these terms.
 * If you do not agree with these terms, please do not use, install, modify or redistribute
 * this Software.
 * 
 * In consideration of your agreement to abide by the following terms, and subject to these
 * terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
 * this original Seapine software (the Software), to use, reproduce, modify and redistribute
 * the Software, with or without modifications, in source and/or binary forms; provided that
 * if you redistribute the Software in its entirety and without modifications, you must retain
 * this notice and the following text and disclaimers in all such redistributions of the Software.
 * Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
 * or promote products derived from the Software without specific prior written permission from
 * Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
 * implied, are granted by Seapine herein, including but not limited to any patent rights that
 * may be infringed by your derivative works or by other works in which the Software may be
 * incorporated.
 * 
 * The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
 * OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
 * 
 * IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
 * UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
 * IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using SHDocVw;

namespace SCC_File_Diff_Report_Utility
{
    class htmlReporter
    {
        static public string fileName;
        static public StreamWriter writer = null;
        static public void CreateReportFile(string ttFilter, string file)
        {

            fileName = file;
            FileInfo tempFile = new FileInfo(fileName);
            if (tempFile.Exists)
            {
                tempFile.Delete();
            }

            FileStream outputfile = null;
            outputfile = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.Write);

            writer = new StreamWriter(outputfile);
            writer.BaseStream.Seek(0, SeekOrigin.End);
            WriteLine("<HTML>");
            WriteLine("<HEAD>");
            WriteLine("<TITLE>");
            WriteLine("Source Code File List");
            WriteLine("</TITLE>");

            WriteLine("<style>");
            WriteLine("table {text-align: left; font-size: 16px; font-family: courier new; background: #c0c0c0;}");
            WriteLine("h2 {text-align: center;font-size: 22px;font-family: courier new;}");
            WriteLine("h3 {text-align: right;font-size: 18px; font-family: courier new;}");
            WriteLine("</style>");

            WriteLine("</HEAD>");

            WriteLine("<BR><BR><h2>"+ ttFilter +"</H2>");
            WriteLine("<BODY>");
           
            
        }
        static public void WriteLine(string reportLine)
        {
            writer.WriteLine(reportLine);
            writer.Flush();
        }
        static public void FinishFile()
        {
            

            WriteLine("</BODY>");
            WriteLine("</HTML>");
            writer.Close();

            object o = null;
            SHDocVw.InternetExplorer ie = new
            SHDocVw.InternetExplorerClass();
            IWebBrowserApp wb = (IWebBrowserApp)ie;

            wb.Visible = true;

            //Do anything else with the window here that you wish
            wb.Navigate(fileName, ref o, ref o, ref o, ref o);

        }

        
    }
}
