/*******************************************************************************
 * Copyright 2008 Seapine Software, Inc. All rights reserved.
 * 
 * IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
 * in consideration of your agreement to the following terms, and your use, installation,
 * modification or redistribution of this Software constitutes acceptance of these terms.
 * If you do not agree with these terms, please do not use, install, modify or redistribute
 * this Software.
 * 
 * In consideration of your agreement to abide by the following terms, and subject to these
 * terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
 * this original Seapine software (the Software), to use, reproduce, modify and redistribute
 * the Software, with or without modifications, in source and/or binary forms; provided that
 * if you redistribute the Software in its entirety and without modifications, you must retain
 * this notice and the following text and disclaimers in all such redistributions of the Software.
 * Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
 * or promote products derived from the Software without specific prior written permission from
 * Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
 * implied, are granted by Seapine herein, including but not limited to any patent rights that
 * may be infringed by your derivative works or by other works in which the Software may be
 * incorporated.
 * 
 * The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
 * OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
 * 
 * IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
 * UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
 * IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/



using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

namespace SCC_File_Diff_Report_Utility
{
    public class sscmexe
    {
        public static string sscmCMD(string s_command)
        {
            string m_strSSCMCallResults = null;
            try
            {
                int result = 1;
                Process sscm = new Process ();
               
                sscm.EnableRaisingEvents = false;
                sscm.StartInfo.UseShellExecute = false;
                sscm.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                sscm.StartInfo.FileName = "C:\\Program Files\\Seapine\\Surround SCM\\sscm.exe";
                sscm.StartInfo.Arguments = s_command;
                sscm.StartInfo.RedirectStandardOutput = true;
                sscm.StartInfo.RedirectStandardInput = true;
                
                sscm.Start();
                sscm.WaitForExit(15000);
                if (sscm.HasExited)
                {
                    result = sscm.ExitCode;
                }
                m_strSSCMCallResults = sscm.StandardOutput.ReadToEnd();
                if (result == 0)
                {
                    Logger.WriteLine("Command result was success for command: " + s_command);
                }
                else if (result == 1)
                {
                    Logger.WriteLine("Command result was Failed for command: " + s_command + "\nCommand response was: " + m_strSSCMCallResults);
                }

            }
            catch (Exception e)
            {
                Logger.WriteLine("SSCM Exception: " + Convert.ToString(e));
            }
            return (m_strSSCMCallResults);
        }
    }
}
